/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.place;


import java.io.OutputStream;
import java.io.PrintStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Date;


/**
 * place ϢΥǡ
 * ֤Ȥ˵ƽϤ롣<BR>
 * MobaPlace 鵯ư롣
 *
 * @see NET.shudo.moba.place.MobaPlace
 */
public
class Logger implements Runnable {
  private static Logger logger = null;

  private PrintStream pout;

  public Logger(OutputStream out) {
    Logger.logger = this;
    this.pout = new PrintStream(out);
  }
  public Logger(String file) {
    OutputStream out = null;
    try {
      out = new FileOutputStream(file);
    }
    catch (IOException e) {}

    Logger.logger = this;
    this.pout = new PrintStream(out);
  }


  private static final int SLEEP_TIME_MILLIS = 3000;
  private static final int MSG_QUEUE_SIZE = 200;

  private String[] msgQueue = new String[MSG_QUEUE_SIZE];
  private Object[] requesterQueue = new Object[MSG_QUEUE_SIZE];
  private long[] timeQueue = new long[MSG_QUEUE_SIZE];
  private int msgCount = 0;

  /**
   * Ϥ롣
   */
  public static void log(Object requester, String msg) {
	// ǤνϤʤ٤ڤ
    Logger logger = Logger.logger;

    if (logger == null)  return;

    // åϿ
    synchronized (Logger.logger) {
      int msgCount = logger.msgCount;

      logger.msgQueue[msgCount] = msg;
      logger.requesterQueue[msgCount] = requester;
      logger.timeQueue[msgCount] = System.currentTimeMillis();
      logger.msgCount++;

      if (logger.msgCount >= MSG_QUEUE_SIZE) {
	logger.msgQueue.notify();
      }
    }

    return;
  }


  public synchronized void run() {
    while (true) {
      try {
	this.wait(SLEEP_TIME_MILLIS);
      }
      catch (InterruptedException e) {}

      if (msgCount > 0) {	// 
	flush();
      }
    }
  }


  private void flush() {	// this Υ˥ƤƤ
    for (int i = 0; i < msgCount; i++) {
      StringBuffer buf = new StringBuffer();

      String msg = msgQueue[i];  msgQueue[i] = null;
      Object requester = requesterQueue[i];  requesterQueue[i] = null;

      // å
      buf.append(new Date(timeQueue[i]));

      buf.append(": ");

      if (requester == null) {
	buf.append("<unknown>");
      }
      else {
	String requesterClassname = requester.getClass().getName();
	int dotIndex = requesterClassname.lastIndexOf('.');
	if (dotIndex >= 0)
	  buf.append(requesterClassname.substring(dotIndex + 1));
	else
	  buf.append(requesterClassname);
      }

      buf.append(": ");

      buf.append(msg);

      // 
      this.pout.println(buf.toString());
    }
    this.pout.flush();

    msgCount = 0;
  }


  protected void finalize() throws Throwable {
    synchronized (this) {
      flush();
    }

    super.finalize();
  }
}
