/*
 * Copyright (C) 1996,1997,1998
 *	SHUDOH Kazuyuki
 *
 * Permission to use, copy, modify and distribute this software
 * and its documentation for non-commercial purposes and without
 * fee is hereby granted provided this copyright notice.
 *
 * $Id$
 */

package NET.shudo.moba.place;


import java.io.InputStream;
import java.io.OutputStream;
import java.io.FileInputStream;	// for optimization of throughput
import java.io.BufferedInputStream;	// for optimization of throughput
import java.io.BufferedOutputStream;	// for optimization of throughput
import java.io.IOException;
import java.net.Socket;
import java.net.InetAddress;
import java.lang.reflect.Constructor;	// ThreadReader  instance 
import NET.shudo.moba.lang.MobaThread;
import NET.shudo.moba.lang.PlaceAddress;
import NET.shudo.moba.io.ThreadReader;
import NET.shudo.moba.io.ObjectReader;


/**
 * ҤȤĤΥåɤ졢ư륯饹<BR>
 * ThreadServer 鵯ư롣
 *
 * @see NET.shudo.moba.place.ThreadServer
 */
public
class ThreadImporter implements Runnable {
  InputStream in;
  OutputStream out;	// optional
  Socket sock;		// optional
  String filename;	// optional
  private boolean debug = false;


  protected ThreadImporter(Socket sock, boolean debug)
	throws IOException {
    this(sock.getInputStream(), sock.getOutputStream(), debug);
    this.sock = sock;
  }
  protected ThreadImporter(String fname, boolean debug)
	throws IOException {
    this(new FileInputStream(fname), null, debug);
    this.filename = fname;
  }
  private ThreadImporter(InputStream in, OutputStream out, boolean debug) {
//    this.in = new BufferedInputStream(in, 32 * 1024);
//    this.out = new BufferedOutputStream(out, 32 * 1024);
    this.in = in;  this.out = out;
    this.debug = debug;
  }


  public void run() {
    boolean success = true;	// 

    // 饹
    MobaClassLoader loader = null;
    {
      PlaceAddress classSrc = null;
      try {
	if (sock != null)	{	// ThreadExporter ȤȤ
	  int len;
	  len = in.read() << 8;
	  len |= in.read();
	  byte[] bArray = new byte[len];
	  in.read(bArray);
	  String genedPlace = new String(bArray);
if (debug) {
  System.out.println("ThreadImporter#run(): place on which the thread generated is `" + genedPlace + "'");
  System.out.flush();
}
	  classSrc = new PlaceAddress(genedPlace);
	}
	else if (filename != null)
	  classSrc = ThreadReader.generatedPlaceFromFile(filename);
      }
      catch (IOException e) {  if (debug)  e.printStackTrace();  }

      if (classSrc != null) {
	try {
	  loader = MobaClassLoader.get(classSrc);
	  loader.debug(debug);

	  // ȥȤ䤹
	  loader.register();
	}
	catch (IOException e) {
	  success = false;
	  if (debug) { e.printStackTrace(); System.out.flush(); }
	}
      }
    }


    ObjectReader thrIn = null;
    try {
      thrIn = new ThreadReader(MobaPlace.threadPool, in, loader);
    }
/*	⡼Ȥ
    try {
      Class clazz = loader.loadClass("NET.shudo.moba.io.ThreadReader");
	// ⡼Ȥ
      Class[] argClazz = new Class[2];
      argClazz[0] = Class.forName("java.lang.ThreadGroup");
      argClazz[1] = Class.forName("java.io.InputStream");
      Constructor readerInit = clazz.getConstructor(argClazz);

      Object[] args = new Object[2];
      args[0] = MobaPlace.threadPool;
      args[1] = in;

      thrIn = (ObjectRead)readerInit.newInstance(args);
	// attach imported thread to MobaPlace.threadPool
	// this ThreadReader loads classes via network
    }
*/
    catch (Exception e) {
      success = false;
      if (debug) { e.printStackTrace(); System.out.flush(); }
    }



    // åɤμ
    MobaThread thread = null;

    if (success) {
      try {
	if (debug)
	  System.out.println("ThreadImporter: now reading a thread..");
	thread = (MobaThread)thrIn.readObject();
      }
      catch (Exception e) {
	success = false;
	if (debug)  e.printStackTrace();
      }
      Logger.log(this, "receipt " + (success?"success":"failed") + ".");
      if (debug)
	System.out.println("ThreadImporter: reading is done (" +
		(success?"success":"failure") + ").");
    }

    if (success) {	// 
      // notify
      PlaceEventNotifier notifier = MobaPlace.eventNotifier();
      if (notifier != null) {
	if (this.sock != null) {
	  notifier.comeNotify(
		sock.getInetAddress().getHostName(), -1, thread);
	}
	else if (this.filename != null) {
	  notifier.startedNotify(thread);
	}
      }
    }

    // close
    try {
      in.close();
      if (out != null)  out.close();
      if (sock != null)  sock.close();
    }
    catch (IOException e) {  if (debug)  e.printStackTrace();  }

    if (success) {	// 
      // 줿åɤ resume
      thread.resume();
if (debug) {
System.out.println("listing by ThreadImporter (resumed thread):");
(new NET.shudo.moba.util.ThreadLister()).listAllThreads(System.out);
System.out.flush();
}

      // 쥹åɤνλԤ
      boolean joinDone;
      do {
	joinDone = true;
	try {
	  thread.join();
	}
	catch (InterruptedException e) { joinDone = false; }
      } while (!joinDone);

if (debug) {
System.out.println("listing by ThreadImporter (join done):");
(new NET.shudo.moba.util.ThreadLister()).listAllThreads(System.out);
System.out.flush();
}
    }	// if (success)
    else {
if (debug) {
System.out.println("Migration failed.");
System.out.flush();
}
    }


    // 饹λȥȤ򸺤餹
    if (loader != null)  loader.unregister();
  }
}
